angular.module('starter.controllers', [])

.controller('AppCtrl', ['$ionicPlatform', '$window', function($ionicPlatform, $window) { 
    $ionicPlatform.ready(function() { 
  /*
      if(window.analytics != undefined)
         window.analytics.trackView('Technotip.org App');
 */  
      cordova.plugins.notification.local.isPresent(1, function (result) { 
              if(result == true)
              {
                    var now  = new Date().getTime(),
                          time = new Date(now +  60*1000*60*9);
                 cordova.plugins.notification.local.update({
                    id: 1,
                    title: 'Technotip.org',
                    text: 'New articles on your favorite site ..',
                    icon: "",       
                    every: 21600,
                    at: time    
                 });
            }
            else
            {
                    var now  = new Date().getTime(),
                          time = new Date(now +  60*1000*60*9);           
               cordova.plugins.notification.local.schedule([{
                    id: 1,
                    title: 'Technotip.org',
                    text: 'New articles on your favorite site ..',
                    icon: "",       
                    every: 21600,
                    at: time
                }]);           
            }      
    
     });
 
         cordova.plugins.notification.local.on('click', function(){
                           $window.location = '#/app/playlists';
         }); 
 
 
 });


}])

.controller('Home', function($scope, $stateParams, $ionicPopup, $ionicModal, Home) {
   $scope.loading = true;
   $scope.page     = 1;
   $scope.loadList = function(forceRefresh){ 
        Home.get(forceRefresh, $scope.page).then(function(result){ 
            $scope.loading = false;
            $scope.posts = result;  
        }).finally(function(){
                      $scope.$broadcast("scroll.refreshComplete");
        });  
   }; $scope.loadList(false);
 
  $scope.navPost = function(task){ 

            if(task == 'p') 
                 $scope.page += 1;
            else
                 $scope.page -= 1;
         
            if($scope.page <  1)
               $scope.page = 1;
        
            $scope.loading = true;
             Home.get(true, $scope.page).then(function(result){ 
           $scope.loading = false;
            if(result.length != 0)
                $scope.posts = result;  
            else
            {
                           $ionicPopup.alert({
                             title: 'End of posts',
                             template: 'This seems to be the end of posts..'
                           });             
            }
        });
 }
  $ionicModal.fromTemplateUrl('templates/brand.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
  });
 $scope.brand = function(){
    $scope.modal.show();    
 }
  $scope.closeModal = function() {
    $scope.modal.hide();
  };
 
if(window.analytics != undefined) 
    window.analytics.trackView('Homepage');
})

.controller('Post', function($scope, $stateParams, $ionicModal, $ionicPopup, $window, Post, CategoryName, Author, Comments, PostNav){
   $scope.loadPost = function(forceRefresh){ 
   $scope.loading  = true;
   $scope.user_flag= false;
    Post.get(forceRefresh, $stateParams.post_id).then(function(result){
                     $scope.loading  = false;
                     $scope.post = result;

    if(window.analytics != undefined)
        window.analytics.trackView('Reading: '+result.title.rendered);
    
        if($window.localStorage.getItem('bookmark') != null)
        {
          var one  = JSON.parse($window.localStorage.getItem('bookmark'));
          $scope.heart = 'ion-android-favorite-outline';
          for(var i=0; i<one.length; i++)
          { 
                if(result.id == one[i].id)
                      $scope.heart = 'ion-android-favorite';
          }
        }else{$scope.heart = 'ion-android-favorite-outline';}  
  
                     CategoryName.get(forceRefresh, result.categories[0]).then(function(cat){
                        $scope.categories = cat;
                     });
                     Author.get(forceRefresh, result.author).then(function(user){
                        $scope.user_flag= true;
                        $scope.user = user;
                     });
                }).finally(function(){
                      $scope.$broadcast("scroll.refreshComplete");
    });       
  }; $scope.loadPost(false);


  $ionicModal.fromTemplateUrl('templates/comments.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
  });


 $scope.loadComments = function(id){
    $scope.loading1 = true;
        $scope.modal.show();
    Comments.get(id).then(function(comments_result){
        $scope.loading1 = false;
        $scope.comments = comments_result; 
    });
 }

  $scope.closeModal = function() {
    $scope.modal.hide();
  };

  $scope.navPost = function(date, task){ 
            $scope.loading = true;
             PostNav.get(date, task).then(function(result){ 
            $scope.loading = false; 

                    if(result.length != 0)
                    {
                       if($window.localStorage.getItem('bookmark') != null)
                       {
          var one  = JSON.parse($window.localStorage.getItem('bookmark'));
          $scope.heart = 'ion-android-favorite-outline';
          for(var i=0; i<one.length; i++)
          {  
                if(result.id == one[i].id)
                      $scope.heart = 'ion-android-favorite';
          }
        }else{$scope.heart = 'ion-android-favorite-outline';}  

                          $scope.post = result[0]; 
               
                   if(window.analytics != undefined)
                         window.analytics.trackView('Reading: '+result[0].title.rendered);
              
                          CategoryName.get(true, result[0].categories[0]).then(function(cat){
                            $scope.categories = cat;
                         });
                         Author.get(true, result[0].author).then(function(user){
                            $scope.user_flag= true;
                            $scope.user = user;
                         });                
                    }
                    else
                    {
                           $ionicPopup.alert({
                             title: 'End of posts',
                             template: 'This seems to be the end of posts..'
                           });  
                    }
        });
 }

$scope.bookmark = function(title, id, heart){
    if(heart == 'ion-android-favorite')
    {
      var one = JSON.parse($window.localStorage.getItem('bookmark'));
   
      if(one.length > 500)
         one.shift();
     
      for(var i=0; i<one.length; i++)
      {
          if(id == one[i].id) 
          {
              one.splice(i, 1);
              $window.localStorage.setItem('bookmark', JSON.stringify(one));
              $scope.heart = 'ion-android-favorite-outline';         
          }
      }
    }
    else
    {
        var temp = {'title': title, 'id': id};

       if($window.localStorage.getItem('bookmark') != null)
       {
          var one = JSON.parse($window.localStorage.getItem('bookmark'));
                one.push(temp);
          $window.localStorage.setItem('bookmark', JSON.stringify(one));
       }
       else
       {
         var array = [];
              array.push(temp);
         $window.localStorage.setItem('bookmark', JSON.stringify(array));
       }             
             $scope.heart = 'ion-android-favorite';
    }
}

})

.controller('AuthorPost', function($scope, $stateParams,  $ionicPopup, AuthorPost, Author){
    $scope.loadAuthorPost = function(forceRefresh){
    $scope.loading   = true;
    $scope.user_flag= false;
    $scope.page = 1;
    AuthorPost.get(forceRefresh, $stateParams.id, $scope.page).then(function(result){
      $scope.loading   = false;
      $scope.posts = result;
      Author.get(true, $stateParams.id).then(function(user){
        $scope.user_flag= true;
        $scope.user = user;
 if(window.analytics != undefined)
    window.analytics.trackView('Checking '+user.name+'s posts');
      });  
  }).finally(function(){
                      $scope.$broadcast("scroll.refreshComplete");
    });       
    }; $scope.loadAuthorPost(false);
  
  $scope.navPost = function(task){
     
            if(task == 'p')
             $scope.page += 1;
            else
             $scope.page -= 1 ;
       
            if($scope.page < 1)
               $scope.page = 1;
 
            $scope.loading = true;
             AuthorPost.get(true, $stateParams.id, $scope.page).then(function(result){ 
           $scope.loading = false;
            if(result.length != 0)
                $scope.posts = result;  
            else
            {
                           $ionicPopup.alert({
                             title: 'End of posts',
                             template: 'This seems to be the end of posts..'
                           });             
            }
        });
 } 

})

.controller('Categories', function($scope, Categories){
    $scope.loadList = function(forceRefresh){
        $scope.loading = true;    
    Categories.get(forceRefresh).then(function(result){
              $scope.loading = false;
              $scope.categories = result;
  }).finally(function(){
                          $scope.$broadcast("scroll.refreshComplete");
        });      
    }; $scope.loadList(false);
      if(window.analytics != undefined)
         window.analytics.trackView('Category List'); 
})

.controller('Category', function($scope, $stateParams, Category, CategoryName){
    $scope.loadList = function(forceRefresh){
        $scope.loading = true;
        $scope.user_flag = false;
        $scope.page = 1;
        Category.get(forceRefresh, $stateParams.id, $scope.page).then(function(result){
           $scope.loading = false;
           $scope.posts = result;

           CategoryName.get(true, $stateParams.id, $scope.page).then(function(cat){
                $scope.user_flag = true;
                $scope.categories = cat;
     if(window.analytics != undefined)
         window.analytics.trackView('Reading Category: '+cat.name);
           });
        }).finally(function(){
                          $scope.$broadcast("scroll.refreshComplete");
        });      
    }; $scope.loadList(false);
    $scope.navPost = function(task){
      $scope.loading = true;
      if(task == 'p')
        $scope.page += 1;
      else
       $scope.page -= 1;
     
        if($scope.page < 1)
           $scope.page = 1;
      
      Category.get(true, $stateParams.id, $scope.page).then(function(result){
             $scope.loading = false; 
            if(result.length != 0)
                $scope.posts = result;  
            else
            {
                           $ionicPopup.alert({
                             title: 'End of posts',
                             template: 'This seems to be the end of posts..'
                           });             
            } 
       });
    }
})

.controller('Pages', function($scope, Pages){
    $scope.loadList = function(forceRefresh){
        $scope.loading = true;
        Pages.get(forceRefresh).then(function(result){
            $scope.loading = false;
            $scope.pages = result;
        }).finally(function(){
                              $scope.$broadcast("scroll.refreshComplete");
        });        
    }; $scope.loadList(false);
  
    if(window.analytics != undefined)  
       window.analytics.trackView('Pages List');
})

.controller('Page', function($scope, $stateParams, $ionicPopup, $ionicModal, Page, PageNav, Author, Comments){
    $scope.loadList = function(forceRefresh){
        $scope.loading = true;
        Page.get(forceRefresh, $stateParams.id).then(function(result){
            $scope.loading = false;
            $scope.post = result;
           if(window.analytics != undefined)
            window.analytics.trackView('Reading Page: '+result.title.rendered);
             Author.get(true, result.author).then(function(user){
                $scope.user_flag= true;
                $scope.user = user;
              });  
        }).finally(function(){
                              $scope.$broadcast("scroll.refreshComplete");
        });        
    }; $scope.loadList(false); 
  
    $scope.navPage = function(date, task)   { 
          $scope.loading = true;
      PageNav.get(date, task).then(function(result){ 
            $scope.loading = false;
            if(result.length != 0)
            {
                        $scope.post = result[0];
                        $scope.user_flag= false; 
                        Author.get(true, result[0].author).then(function(user){
                            $scope.user_flag= true;
                            $scope.user = user;
                        });  
            }
            else
            {
                           $ionicPopup.alert({
                             title: 'End of pages',
                             template: 'This seems to be the end of pages..'
                           });             
            } 
      });
  }
 

  $ionicModal.fromTemplateUrl('templates/comments.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
  });


 $scope.loadComments = function(id){
    $scope.loading1 = true;
        $scope.modal.show();
    Comments.get(id).then(function(comments_result){
        $scope.loading1 = false;
        $scope.comments = comments_result; 
    });
 }

  $scope.closeModal = function() {
    $scope.modal.hide();
  };


})

.controller('Authors', function($scope, Authors){
   $scope.loadList = function(forceRefresh) {
    $scope.loading = true;
    Authors.get(forceRefresh).then(function(result){
        $scope.loading = false;
        $scope.users = result;  
    }).finally(function(){
                              $scope.$broadcast("scroll.refreshComplete");
        });        
    }; $scope.loadList(false);
if(window.analytics != undefined)
  window.analytics.trackView('Checking Contributers List');
})

.controller('Search', function($scope, Search){
    $scope.search = function(query){
          $scope.loading = true;
        if(query != '' && query != undefined)
        {
            if(window.analytics != undefined)
               window.analytics.trackView('Searching: '+query);
      
            Search.query(query).then(function(result){
                       $scope.loading = false;
                       $scope.posts = result;
                                  }).finally(function(){
                                  $scope.$broadcast("scroll.refreshComplete");
            });         
        }
        else
             $scope.loading = false;  
    }
})

.controller('Social', ['$scope', function($scope){

  
        $scope.share = function(target, title, link){
            if(window.analytics != undefined)
            window.analytics.trackView('Sharing '+title);
            if(link == '')
              link = 'http://technotip.org/app';
 
             if(target == 'w')
             {
                  window.plugins.socialsharing
                    .shareViaWhatsApp(title, '', link);           
             }else if(target == 't')
            {
              window.plugins.socialsharing
                .shareViaTwitter(title, '', link);
            }else if(target == 'f')
            {
              window.plugins.socialsharing
                .shareViaFacebook(title, '', link);
            }else if(target == 'sms')
            {
                   window.plugins.socialsharing
                    .shareViaSMS(title+' '+link); 
            } 
            else {
           var temp = 'You\'d love this ';
                title += '   '+link
                   window.plugins.socialsharing
                   .shareViaEmail(title, temp, '');
            }
       
        }
}])

.controller('Bookmarks', function($scope, $window){
    $scope.loading = true;
    $scope.loadList = function() {
        $scope.error = false;
        if($window.localStorage.getItem('bookmark') != null)
        {
           var temp = JSON.parse($window.localStorage.getItem('bookmark'));
           temp.reverse();
           $scope.posts = temp;
        }
        else
        {
          $scope.error = true;
        }
        $scope.$broadcast("scroll.refreshComplete");
        $scope.loading = false;
    }; $scope.loadList();
if(window.analytics != undefined)  
  window.analytics.trackView('Checking Bookmark List');
});
